// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },

        //此处均是默认值。不用动
        ScrollBarClick: false,
        MaxMoveY: null,
        MaxMoveX: null,
        maxY: null,
        minY: null,
        minX: null,
        maxX: null,

    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},
    /**
     * 将脚本挂在要拖动的 scrollBar 节点上
     */
    start() {
        //节点组件获取
        this._scrollView = this.node.parent.getComponent(cc.ScrollView);
        this.scrollBarNode = this.node;
        this.BarNode = this.node.getChildByName('bar');
        this.scrollStac = 0;
        //注册触摸监听
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_START, this._onStartTouch, this, true);
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_MOVE, this._onMoveTouch, this, true);
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_END, this._onEndTouch, this, true);

        //最大移动范围 是否要滚动bar的范围
        this.scheduleOnce(() => {

            //获取滚动方向 1 == 竖； 0 == 横
            this.direction = this.scrollBarNode.getComponent(cc.Scrollbar).direction;
            let pos2 = this.scrollBarNode.convertToWorldSpaceAR(cc.v2(0, 0));
            // console.log(pos2, '>....pos2')
            let _scrollBarNodeAncY = this.scrollBarNode.anchorY;
            let _scrollBarNodeAncX = this.scrollBarNode.anchorX;

            //计算点击范围是否是scrollbar
            if (this.direction == 1) {
                let maxSide = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? 1 - _scrollBarNodeAncY : _scrollBarNodeAncY;
                let minSide = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? _scrollBarNodeAncY : 1 - _scrollBarNodeAncY;
                this.MaxMoveY = pos2.y + (this.scrollBarNode.height * maxSide) - this.BarNode.height;
                this.maxY = pos2.y + (this.scrollBarNode.height * maxSide);
                this.minY = pos2.y - (this.scrollBarNode.height * minSide);
                this.maxX = pos2.x;
                this.minX = pos2.x - 30;

            } else if (this.direction == 0) {
                this.maxY = pos2.y + this.scrollBarNode.height;
                this.minY = pos2.y;
                this.maxX = pos2.x + this.scrollBarNode.width * _scrollBarNodeAncX;
                this.minX = pos2.x - this.scrollBarNode.width * _scrollBarNodeAncX;
                this.MaxMoveX = this.maxX - this.BarNode.width;
            }

            console.log(this.maxX, this.minX, '边界', this.minY, this.maxY, this.MaxMoveY)

        }, 1)
    },

    //触摸开始监听
    _onStartTouch(event) {
        // console.log(event.touch.getLocation().y, '被点击了', event.touch.getLocation().x,)
        // console.log(this.maxX, this.minX, '被点击了22222222', this.minY, this.maxY,)

        let touchLoc = event.touch.getLocation();
        if (touchLoc.x >= this.minX && touchLoc.x <= this.maxX && touchLoc.y >= this.minY && touchLoc.y <= this.maxY) {
            // console.log('LAIZHEonStartTouch')
            //>>>>>>>>>>>>>
            let getContentPosition = this._scrollView.getContentPosition();
            let getMaxScrollOffset = this._scrollView.getMaxScrollOffset();
            this.scrollStac = Math.abs(getContentPosition.y / getMaxScrollOffset.y)*(this.MaxMoveY - this.minY);
           
            // console.log(getContentPosition, ">>>>>>>>>getContentPosition>>>",this.scrollStac, getContentPosition.y / getMaxScrollOffset.y)

            //>>>>>>>>>>>>>>
            this.scrollBarNode.opacity = 255;
            this.ScrollBarClick = true;

            event.stopPropagation();
        } else {
            this.ScrollBarClick = false;

        }

    },

    //触摸移动监听
    _onMoveTouch(event) {
        let delta = event.touch.getDelta();
        //竖形滚动
        if (this.ScrollBarClick == true && this.direction == 1) {
            let oldNum = this.scrollStac;
            this.scrollStac = this.scrollStac + delta.y;
            let percent2 = this.scrollStac / (this.MaxMoveY - this.minY);
            if (percent2 > 1) {
                this.scrollStac = oldNum;
            } else if (percent2 < 0) {
                this.scrollStac = oldNum;

            }
            this._scrollView.scrollTo(cc.v2(0, percent2))          
            event.stopPropagation();

        }

        //横向滚动
        // if (this.ScrollBarClick == true && this.direction == 0) {
        //     let oldPos = this.BarNode.x;
        //     this.BarNode.x += delta.x;
        //     let pos = this.BarNode.convertToWorldSpaceAR(cc.v2(0, 0));
        //     let percent = (pos.x - this.minX) / (this.scrollBarNode.width - this.BarNode.width);
        //     cc.log(pos.x, '>>>>>>>pos.x', percent)

        //     //判断最边缘位置
        //     if (pos.x >= this.MaxMoveX) {
        //         this.BarNode.x = oldPos;
        //     } else if (pos.x <= this.minX) {
        //         this.BarNode.x = oldPos;

        //     }

        //     //调用scrollview 滚动方法
        //     let scrollPercent = percent > 0 ? (percent) : 0;
        //     this._scrollView.scrollTo(cc.v2(scrollPercent, 0));

        //     event.stopPropagation();

        // }
        // this.BarNode.opacity = 255;
        // this.scrollBarNode.opacity = 255;
    },

    //触摸结束监听
    _onEndTouch(event) {
        // console.log('被点击了》》》》》结束')
        this.ScrollBarClick = false;


    },
    // update (dt) {},
});
