// Learn cc.Class:
//  - https://docs.cocos.com/creator/manual/en/scripting/class.html
// Learn Attribute:
//  - https://docs.cocos.com/creator/manual/en/scripting/reference/attributes.html
// Learn life-cycle callbacks:
//  - https://docs.cocos.com/creator/manual/en/scripting/life-cycle-callbacks.html

cc.Class({
    extends: cc.Component,

    properties: {
        // foo: {
        //     // ATTRIBUTES:
        //     default: null,        // The default value will be used only when the component attaching
        //                           // to a node for the first time
        //     type: cc.SpriteFrame, // optional, default is typeof default
        //     serializable: true,   // optional, default is true
        // },
        // bar: {
        //     get () {
        //         return this._bar;
        //     },
        //     set (value) {
        //         this._bar = value;
        //     }
        // },

       
        ScrollBarClick: false,
        MaxMoveY: null,
        MaxMoveX: null,
        maxY: null,
        minY: null,
        minX: null,
        maxX: null,

    },

    // LIFE-CYCLE CALLBACKS:

    // onLoad () {},
    /**
     * Hang the script on the scrollBar node to be dragged
     */
    start() {
        //
        this._scrollView = this.node.parent.getComponent(cc.ScrollView);
        this.scrollBarNode = this.node;
        this.BarNode = this.node.getChildByName('bar');
        this.content = this._scrollView.node.getChildByName('view').getChildByName('content');

        //The maximum range of movement whether you want the scroll bar range
        this.scheduleOnce(() => {

            //Get the scroll direction 1 == vertical; 0 == horizontal
            this.direction = this.scrollBarNode.getComponent(cc.Scrollbar).direction;
            let pos2 = this.scrollBarNode.convertToWorldSpaceAR(cc.v2(0, 0));
            // console.log(pos2, '>....pos2')
            let _scrollBarNodeAncY = this.scrollBarNode.anchorY;
            let _scrollBarNodeAncX = this.scrollBarNode.anchorX;
            let maxSideX = (1 - _scrollBarNodeAncX) >= _scrollBarNodeAncX ? 1 - _scrollBarNodeAncX : _scrollBarNodeAncX;
            let minSideX = (1 - _scrollBarNodeAncX) >= _scrollBarNodeAncX ? _scrollBarNodeAncX : 1 - _scrollBarNodeAncX;
            let maxSideY = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? 1 - _scrollBarNodeAncY : _scrollBarNodeAncY;
            let minSideY = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? _scrollBarNodeAncY : 1 - _scrollBarNodeAncY;
            // console.log(maxSideX, minSideX, '边界比例', maxSideY, minSideY)

            //Calculate whether the click range is scrollbar
            if (this.direction == 1) {
                this.MaxMoveY = pos2.y + (this.scrollBarNode.height * maxSideY) - this.BarNode.height;
                this.maxY = pos2.y + this.scrollBarNode.height * maxSideY;
                this.minY = pos2.y - this.scrollBarNode.height * minSideY;
                this.maxX = pos2.x + this.scrollBarNode.width * minSideX;
                this.minX = pos2.x - this.scrollBarNode.width * maxSideX;

            } else if (this.direction == 0) {
                this.maxY = pos2.y + this.scrollBarNode.height * maxSideY;
                this.minY = pos2.y + this.scrollBarNode.height * minSideY;
                this.maxX = pos2.x + this.scrollBarNode.width * maxSideX;
                this.minX = pos2.x - this.scrollBarNode.width * minSideX;
                this.MaxMoveX = this.maxX + this.scrollBarNode.height * maxSideX - this.BarNode.width;
            }

            // console.log(this.maxX, this.minX, '边界', this.minY, this.maxY, this.direction, this.MaxMoveY)
           
           //Monitor content changes in the size, resize bar and the maximum moving distance
            this.content.on(cc.Node.EventType.SIZE_CHANGED, this._ResetMaxMove, this);

        }, 1)
    },

    //reset max Move
    _ResetMaxMove() {
        let pos2 = this.scrollBarNode.convertToWorldSpaceAR(cc.v2(0, 0));
        let _scrollBarNodeAncY = this.scrollBarNode.anchorY;
        let _scrollBarNodeAncX = this.scrollBarNode.anchorX;
        let maxSideX = (1 - _scrollBarNodeAncX) >= _scrollBarNodeAncX ? 1 - _scrollBarNodeAncX : _scrollBarNodeAncX;
        let minSideX = (1 - _scrollBarNodeAncX) >= _scrollBarNodeAncX ? _scrollBarNodeAncX : 1 - _scrollBarNodeAncX;
        let maxSideY = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? 1 - _scrollBarNodeAncY : _scrollBarNodeAncY;
        let minSideY = (1 - _scrollBarNodeAncY) >= _scrollBarNodeAncY ? _scrollBarNodeAncY : 1 - _scrollBarNodeAncY;
    
        if (this.direction == 1) {
            this.MaxMoveY = pos2.y + (this.scrollBarNode.height * maxSideY) - this.BarNode.height;
            this.maxY = pos2.y + this.scrollBarNode.height * maxSideY;
            this.minY = pos2.y - this.scrollBarNode.height * minSideY;
            this.maxX = pos2.x + this.scrollBarNode.width * minSideX;
            this.minX = pos2.x - this.scrollBarNode.width * maxSideX;

        } else if (this.direction == 0) {
            this.maxY = pos2.y + this.scrollBarNode.height * maxSideY;
            this.minY = pos2.y + this.scrollBarNode.height * minSideY;
            this.maxX = pos2.x + this.scrollBarNode.width * maxSideX;
            this.minX = pos2.x - this.scrollBarNode.width * minSideX;
            this.MaxMoveX = this.maxX + this.scrollBarNode.height * maxSideX - this.BarNode.width;
        }
    },

    onEnable() {
        //注册触摸监听
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_START, this._onStartTouch, this, true);
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_MOVE, this._onMoveTouch, this, true);
        cc.find('Canvas').on(cc.Node.EventType.TOUCH_END, this._onEndTouch, this, true);
        // this.content.on(cc.Node.EventType.SIZE_CHANGED, this._ResetMaxMove, this);

    },
    onDisable() {
        //注册触摸监听
        cc.find('Canvas').off(cc.Node.EventType.TOUCH_START, this._onStartTouch, this, true);
        cc.find('Canvas').off(cc.Node.EventType.TOUCH_MOVE, this._onMoveTouch, this, true);
        cc.find('Canvas').off(cc.Node.EventType.TOUCH_END, this._onEndTouch, this, true);
        this.content.off(cc.Node.EventType.SIZE_CHANGED, this._ResetMaxMove, this);

    },
    //触摸开始监听
    _onStartTouch(event) {
        // console.log(event.touch.getLocation().y, '被点击了', event.touch.getLocation().x,)
        // console.log(this.maxX, this.minX, '被点击了22222222', this.minY, this.maxY,)

        let touchLoc = event.touch.getLocation();
        if (touchLoc.x >= this.minX && touchLoc.x <= this.maxX && touchLoc.y >= this.minY && touchLoc.y <= this.maxY) {
            // console.log('LAIZHEonStartTouch')
            this.ScrollBarClick = true;
            this.scrollBarNode.opacity = 255;
            event.stopPropagation();
        } else {
            this.ScrollBarClick = false;

        }

    },

    //触摸移动监听
    _onMoveTouch(event) {
        let delta = event.touch.getDelta();
        //ver - move
        if (this.ScrollBarClick == true && this.direction == 1) {
            let oldPos = this.BarNode.y;
            this.BarNode.y += delta.y;
            let pos = this.BarNode.convertToWorldSpaceAR(cc.v2(0, 0));
            let percent = (this.MaxMoveY - pos.y) / (this.MaxMoveY - this.minY);
            console.log(pos.y, '>>>>>pos.y', this.MaxMoveY, this.BarNode.height)
            //Judging the most edge position
            if (pos.y >= this.MaxMoveY) {
                this.BarNode.y = oldPos;
            } else if (pos.y <= this.minY) {
                this.BarNode.y = oldPos;

            }

            //Call the scrollview scroll method. You can view the component documentation of the scrollview.
            let scrollPercent = 1 - percent > 0 ? (1 - percent) : 0;
            this._scrollView.scrollTo(cc.v2(0, scrollPercent));
            event.stopPropagation();

        }

        //hor - move
        if (this.ScrollBarClick == true && this.direction == 0) {
            let oldPos = this.BarNode.x;
            this.BarNode.x += delta.x;
            let pos = this.BarNode.convertToWorldSpaceAR(cc.v2(0, 0));
            let percent = (pos.x - this.minX) / (this.scrollBarNode.width - this.BarNode.width);
            // cc.log(pos.x, '>>>>>>>pos.x', percent)

            //Judging the most edge position
            if (pos.x >= this.MaxMoveX) {
                this.BarNode.x = oldPos;
            } else if (pos.x <= this.minX) {
                this.BarNode.x = oldPos;

            }

            //Call the scrollview scroll method. You can view the component documentation of the scrollview.
            let scrollPercent = percent > 0 ? (percent) : 0;
            this._scrollView.scrollTo(cc.v2(scrollPercent, 0));

            event.stopPropagation();

        }
        this.BarNode.opacity = 255;
        this.scrollBarNode.opacity = 255;
    },

    //触摸结束监听
    _onEndTouch(event) {
        // console.log('被点击了》》》》》结束')
        this.ScrollBarClick = false;


    },
    // update (dt) {},
});
